package logic;

import java.io.*;
import java.util.*;

/**
 * Class to create a random author. Some cultures are supported and
 * they have a probability distribution (thorwalers dont' write much
 * books, for the clich)
 * @author Jens
 *
 */
public class Author implements Serializable{
	private static final long serialVersionUID = 1L;
	private String name, region;
	private int age, deathyear;
	private boolean dead;
	private String align;
	
	/**
	 * Empty Constructor sets random values into Fields 
	 */
	public Author(){
		boolean girl;
		if (new Random().nextInt()%2==0){
			girl=true;
		}
		else{
			girl=false;
		}
		RandomName original = new RandomName(girl);
		this.name = original.getName();
		this.region = original.getRegion();
		this.age = new Random().nextInt(40) + 65;
		if(new Random().nextInt()%7==0){
			this.dead = false;
		}
		else{
			this.dead = true;
		}
		if(this.dead){
			this.deathyear = new Random().nextInt(1000);
		}
		else{
			this.deathyear = 0;
		}
		int alignnumber = new Random().nextInt() % 3;
		switch(alignnumber){
		case 0:
			this.align = "Schwarzmagier";
			break;
		case 1:
			this.align = "Graumagier";
			break;
		default:
			this.align = "Weimagier";
		}
		if(girl){
			this.align = this.align+"in";
		}
	}
	/**
	 * Constructor which gets a name
	 * @param name The Name of the mage
	 * @param isGirl is it a girl?
	 */
	public Author(String name, boolean isGirl){
		this.name = name;
		this.age = new Random().nextInt(40) + 65;
		if(new Random().nextInt()%8==0){
			this.dead = false;
		}
		else{
			this.dead = true;
		}
		if(this.dead){
			this.deathyear = new Random().nextInt(1000);
		}
		else{
			this.deathyear = 0;
		}
		int alignnumber = new Random().nextInt() % 3;
		switch(alignnumber){
		case 0:
			this.align = "Weimagier";
			break;
		case 1:
			this.align = "Graumagier";
			break;
		default:
			this.align = "Schwarzmagier";
		}
		if(isGirl){
			this.align = this.align+"in";
		}
	}
	
	/**
	 * Constructor for Name and Align
	 * @param name Name of the mage
	 * @param align align of the mage
	 */
	public Author (String name, String align){
		this.name = name;
		this.age = new Random().nextInt(40) + 65;
		if(new Random().nextInt()%8==0){
			this.dead = false;
		}
		else{
			this.dead = true;
		}
		if(this.dead){
			this.deathyear = new Random().nextInt(1000);
		}
		else{
			this.deathyear = 0;
		}
		this.align = align;
	}
	
	/**
	 * Constructor with name and the year of birth
	 * @param name the name of the mage
	 * @param birthyear the birthyear of the mage (let's see if he's still alive...)
	 * @param isGirl is it a girl?
	 */
	public Author(String name, int birthyear, boolean isGirl){
		this.name = name;
		this.age = new Random().nextInt(40) + 65;
		if(this.age+birthyear > 2515){
			this.dead = false;
		}
		else{
			this.dead = true;
		}
		if(this.dead){
			this.deathyear = birthyear+this.age;
		}
		else{
			this.deathyear = 0;
		}
		int alignnumber = new Random().nextInt() % 3;
		switch(alignnumber){
		case 0:
			this.align = "Weimagier";
			break;
		case 1:
			this.align = "Graumagier";
			break;
		default:
			this.align = "Schwarzmagier";
		}
		if(isGirl){
			this.align = this.align+"in";
		}
	}
	
	/**
	 * Biggest constructor, sets name, align and birthyear 
	 * @param name the name of the mage
	 * @param align the align of the mage
	 * @param birthyear the birthyear of the mage (let's see if he's still alive...)
	 */
	public Author(String name, String align, int birthyear){
		this.name = name;
		this.age = new Random().nextInt(40) + 65;
		if(this.age+birthyear > 2515){
			this.dead = false;
		}
		else{
			this.dead = true;
		}
		if(this.dead){
			this.deathyear = birthyear+this.age;
		}
		else{
			this.deathyear = 0;
		}
		this.align = align;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getAge() {
		return age;
	}
	public void setAge(int age) {
		this.age = age;
	}
	public int getDeathyear() throws HeIsNotDeadException {
		if (deathyear != 0) {
			return deathyear;
		}
		else{
			throw new HeIsNotDeadException();
		}
	}
	public void setDeathyear(int deathyear) throws HeIsNotDeadException {
		if (dead) {
			this.deathyear = deathyear;
		}
		else{
			throw new HeIsNotDeadException();
		}
	}
	public boolean isDead() {
		return dead;
	}
	public void setDead(boolean dead) {
		this.dead = dead;
	}
	public String getAlign() {
		return align;
	}
	public void setAlign(String align) {
		this.align = align;
	}
	
	public String toString(){
		String toString = this.name+", "+this.align;
		if (this.isDead()){
			toString = toString+", starb im Jahre "+this.deathyear+" BF im Alter von "+this.age+" Jahren.";
		}
		else{
			toString = toString+", zur Zeit "+this.age+" Jahre alt";
		}
		return toString;
	}
	public String getRegion() {
		return region;
	}
}
