package logic;

import java.util.*;

import regions.*;

/**
 * Class sets the random region and gender. Casts after this a random
 * name from the selected region 
 * @author Jens
 *
 */
public class RandomName{
	private String name;
	private String region = "Mittelreich,Mittelreich,Mittelreich,Horasreich,Horasreich,Horasreich,Bornland,Sueden,Sueden,Thorwal,Tulamiden,Tulamiden,Tulamiden,Tulamiden";
	private boolean girl;
	
	/**
	 * Does the whole work in this class
	 * @param girl is it a girl?
	 */
	public RandomName(boolean girl){
		this.girl=girl;
		String[] regions = region.split(",");
		this.region = regions[new Random().nextInt(regions.length)];
		this.name = "Unbekannt";
		if(this.region.equalsIgnoreCase("mittelreich")){
			this.name = new Commoner(this.girl).getName();
		}
		if(this.region.equalsIgnoreCase("horasreich")){
			this.name = new Horasian(this.girl).getName();
		}
		if(this.region.equalsIgnoreCase("bornland")){
			this.name = new Bornian(this.girl).getName();
		}
		if(this.region.equalsIgnoreCase("sueden")){
			this.name = new Southern(this.girl).getName();
		}
		if(this.region.equalsIgnoreCase("thorwal")){
			this.name = new Thorwaler(this.girl).getName();
		}
		if(this.region.equalsIgnoreCase("tulamiden")){
			this.name = new Tulamidian(this.girl).getName();
		}
	}
	
	/**
	 * Names are all hollow words, when they are not given back.
	 * Get them!
	 * @return the name of the author
	 */
	public String getName(){
		return this.name;
	}

	public String getRegion() {
		return region;
	}
}
