package logic;

import java.io.Serializable;
import java.util.Random;

public class Special implements Serializable{
	private static final long serialVersionUID = 1L;
	private final String talent, group;
	private final int end;
	
	/**
	 * generates new Special with value from 2 to 12
	 * @param group
	 * @param talent
	 */
	public Special (String group, String talent){
		this.group = group;
		this.talent = talent;
		this.end = new Random().nextInt(6)+new Random().nextInt(6)+2;
	}
	
	/**
	 * generates a Special out of a Spell with
	 * value from 2 to 12
	 * @param spell
	 */
	public Special (Spell spell){
		this.group = spell.getTokens();
		this.talent = spell.getName();
		this.end = new Random().nextInt(6)+new Random().nextInt(6)+6;
	}
	
	/**
	 * nice little format
	 */
	public String toString(){
		return this.talent+" bis "+this.end;
	}

	/**
	 * 
	 * @return the talent
	 */
	public String getTalent() {
		return talent;
	}

	/**
	 * 
	 * @return the tokens or groups of the special
	 */
	public String getGroup() {
		return group;
	}
}
