package logic;

import java.util.*;

/**
 * This class contains only spells for mages of spread 4 or higher
 * It's no Spell management like in character management programs!
 * @author Jens
 *
 */
public class SpellCollection {
	private ArrayList<Spell> spells;
	private static SpellCollection instance;
	
	/**
	 * Instance like in SpecialCollection for new values every time loading
	 * @return Instance
	 */
	public static SpellCollection getInstance() {
		instance=new SpellCollection();
		return instance;
	}
	
	/**
	 * Constructs the Spell List and fills it with the most common
	 * mage spells
	 */
	public SpellCollection(){
		this.spells = new ArrayList<Spell>();
		spells.add(new Spell("Abvenenum", 'C', 6, "objk"));
		spells.add(new Spell("Accuratum", 'C', 4, "objk"));
		spells.add(new Spell("Adamantium", 'C', 5, "objk elemErz"));
		spells.add(new Spell("Aeolitus", 'B', 5, "umwt elemLuft"));
		spells.add(new Spell("Analys", 'D', 6, "hell meta"));
		spells.add(new Spell("ngste lindern", 'C', 4, "einf"));
		spells.add(new Spell("Arcanovi", 'E', 4, "objk meta"));
		spells.add(new Spell("Armatrutz", 'B', 6, "eign elemErz"));
		spells.add(new Spell("Auracania", 'D', 4, "eign meta"));
		spells.add(new Spell("Aureolus", 'A', 4, "illu"));
		spells.add(new Spell("Auris Nasus", 'D', 5, "illu"));
		spells.add(new Spell("Balsam", 'C', 7, "heil form"));
		spells.add(new Spell("Bannbaladin", 'B', 6, "einf"));
		spells.add(new Spell("Beherrschungen brechen", 'C', 6, "anti herr"));
		spells.add(new Spell("Bewegung stren", 'C', 5, "anti tele"));
		spells.add(new Spell("Blick aufs Wesen", 'C', 5, "hell"));
		spells.add(new Spell("Blick in die Gedanken", 'D', 5, "hell"));
		spells.add(new Spell("Blitz dich find", 'B', 6, "einf"));
		spells.add(new Spell("Caldofrigo", 'E', 4, "objk umwt elemEis elemFeuer"));
		spells.add(new Spell("Claudibus", 'C', 6, "objk"));
		spells.add(new Spell("Corpofresso", 'C', 4, "eign"));
		spells.add(new Spell("Corpofrigo", 'C', 4, "eign elemEis"));
		spells.add(new Spell("Cryptographo", 'C', 6, "objk vers"));
		spells.add(new Spell("Custodisigil", 'C', 6, "objk meta elemFeuer"));
		spells.add(new Spell("Delicioso", 'D', 4, "illu"));
		spells.add(new Spell("Dschinnenruf", 'E', 4, "elem herb"));
		spells.add(new Spell("Dunkelheit", 'C', 4, "umwt"));
		spells.add(new Spell("Duplicatus", 'C', 6, "illu"));
		spells.add(new Spell("Eigenschaft wiederherstellen", 'C', 5, "anti eign"));
		spells.add(new Spell("Einfluss bannen", 'B', 4, "anti einf"));
		spells.add(new Spell("Eisenrost", 'C', 6, "objk temp"));
		spells.add(new Spell("Elementarer Diener", 'D', 4, "elem herb"));
		spells.add(new Spell("Favilludo", 'A', 5, "illu"));
		spells.add(new Spell("Flim Flam", 'A', 7, "umwt"));
		spells.add(new Spell("Foramen", 'C', 6, "hell tele"));
		spells.add(new Spell("Fortifex", 'D', 4, "umwt elemErz"));
		spells.add(new Spell("Fulminictus", 'C', 5, "scha krft"));
		spells.add(new Spell("Gardianum", 'D', 6, "anti krft meta"));
		spells.add(new Spell("Geisterbann", 'C', 5, "anti geis"));
		spells.add(new Spell("Hellsicht trben", 'C', 5, "anti hell"));
		spells.add(new Spell("Horriphobus", 'C', 6, "einf"));
		spells.add(new Spell("Ignifaxius", 'C', 5, "scha elemFeuer"));
		spells.add(new Spell("Illusion auflsen", 'B', 5, "anti illu"));
		spells.add(new Spell("Imperavi", 'E', 4, "herr"));
		spells.add(new Spell("Impersona", 'D', 4, "illu"));
		spells.add(new Spell("Invocatio Maior", 'E', 5, "besw dmo"));
		spells.add(new Spell("Invocatio Minor", 'D', 5, "besw dmo"));
		spells.add(new Spell("Karnifilo", 'C', 4, "einf eign"));
		spells.add(new Spell("Klarum Purum", 'D', 6, "form heil"));
		spells.add(new Spell("Manifesto", 'A', 5, "elem"));
		spells.add(new Spell("Memorans", 'C', 4, "hell eign"));
		spells.add(new Spell("Menetekel", 'B', 5, "illu"));
		spells.add(new Spell("Motoricus", 'C', 6, "tele"));
		spells.add(new Spell("Objectofixo", 'D', 4, "objk temp"));
		spells.add(new Spell("Objectovoco", 'C', 5, "vers"));
		spells.add(new Spell("Objekt entzaubern", 'C', 5, "anti objk"));
		spells.add(new Spell("Odem Arcanum", 'A', 7, "hell krft"));
		spells.add(new Spell("Paralysis", 'C', 7, "form elemErz"));
		spells.add(new Spell("Petectondo", 'B', 5, "form"));
		spells.add(new Spell("Penetrizzel", 'C', 5, "hell"));
		spells.add(new Spell("Pentagramma", 'D', 5, "anti besw dmo geis"));
		spells.add(new Spell("Plumbumbarum", 'B', 7, "einf"));
		spells.add(new Spell("Psychostabilis", 'C', 6, "anti eign"));
		spells.add(new Spell("Reflectimago", 'B', 5, "illu"));
		spells.add(new Spell("Respondami", 'B', 7, "herr"));
		spells.add(new Spell("Ruhe Krper", 'B', 4, "heil"));
		spells.add(new Spell("Salander", 'E', 5, "form"));
		spells.add(new Spell("Sapefacta", 'C', 5, "tele elemLuft elemWasser"));
		spells.add(new Spell("Sensibar", 'C', 6, "hell"));
		spells.add(new Spell("Silentium", 'B', 5, "umwt"));
		spells.add(new Spell("Skelettarius", 'C', 4, "dmo"));
		spells.add(new Spell("Somnigravis", 'B', 5, "einf"));
		spells.add(new Spell("Unberhrt von Satinav", 'C', 4, "objk temp"));
		spells.add(new Spell("Unitatio", 'B', 6, "vers krft"));
		spells.add(new Spell("Vernderung aufheben", 'D', 5, "anti umwt"));
		spells.add(new Spell("Verstndigung stren", 'C', 5, "anti vers"));
		spells.add(new Spell("Verwandlung beenden", 'D', 5, "anti form"));
		spells.add(new Spell("Visibili", 'C', 5, "form"));
		spells.add(new Spell("Vocolimbo", 'B', 5, "illu"));
		spells.add(new Spell("Vogelzwitschern", 'B', 5, "illu"));
		spells.add(new Spell("Weihrauchwolke", 'B', 5, "illu"));
	}
	
	/**
	 * Overloaded constructor to realize spells with up to
	 * 4 tokens
	 * @param name
	 * @param complexity
	 * @param spread
	 * @param token1
	 */
	public void addSpell(String name, char complexity, int spread, String tokens){
		this.spells.add(new Spell(name, complexity, spread, tokens));
	}
	
	/**
	 * Gets a Spell by its name, if any
	 * @param name the name, for search purposes
	 * @return the spell
	 * @throws SpellNotFoundException if there was no such spell
	 */
	public Spell getSpell(String name) throws SpellNotFoundException{
		for (Spell spell : this.spells){
			if(spell.getName().equals(name)){
				return spell;
			}
		}
		throw new SpellNotFoundException();
	}
	
	/**
	 * removes a spell from the list
	 * @param name the name of the spell to remove
	 * @return true, if spell was deleted successfully
	 * @throws SpellNotFoundException if there was no spell with this name
	 */
	public boolean removeSpell(String name) throws SpellNotFoundException{
		return this.spells.remove(this.getSpell(name));
	}
	
	/**
	 * Tries to get some Spells with the given tokens
	 * @param count the amount of spells to give back
	 * @param tokens the tokens
	 * @return an ArrayList with Spells
	 */
	public ArrayList<Spell> getSpellsByToken(int count, ArrayList<String> tokens){
		ArrayList<Spell> founded = new ArrayList<Spell>();
		for (String mytoken : tokens){
			for(Spell spell : this.spells){
				if(spell.getTokens().contains(mytoken)){
					founded.add(spell);
				}
			}
		}
		return someRandomSpells(count, founded);
	}

	/**
	 * Gets some random Spells out of a List
	 * @param count
	 * @param founded
	 * @return
	 */
	private ArrayList<Spell> someRandomSpells(int count, ArrayList<Spell> founded) {
		ArrayList<Spell> someSpells = new ArrayList<Spell>();
		int i = 0;
		while (i<count){
			someSpells.add(founded.get(new Random().nextInt(founded.size())));
			i++;
		}
		removeDoubleValues(someSpells);
		return someSpells;
	}

	/**
	 * Removes doubled spells from a list 
	 * @param someSpells
	 */
	private void removeDoubleValues(ArrayList<Spell> someSpells) {
		Set<Spell> set = new HashSet<Spell>(someSpells);
		someSpells.clear();
		someSpells.addAll(set);
	}
	
	public String toString(){
		String collection = "";
		for(Spell spell: spells){
			collection = collection+spell.toString();
		}
		return collection;
	}

	/**
	 * Get em all
	 * @return an ArrayList of Spells
	 */
	public ArrayList<Spell> getSpells() {
		return spells;
	}

}